/**
 * @author 3GPP T# WG3
 * @version 0.1
 * USimToolkitService defines Toolkit methods, among them 3GPP TS 31.111 specification
 */
package org.3gpp.t.wg3.test.usim.jcapi.userinterface;

import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;


public interface USimToolkitService extends UiccToolkitService {


    /**
     * perform an Envelope SMS Point to Point
     * @param SMS TPDU (SMS-DELIVER) TLV, as String
     * @return APDUResponse Object
     *  Send the following string :
     *  "D1XX8202 8381" + SMS TPDU TLV
     */
    public ADPUResponse envelopeSmsPp(String TPDU);

    /**
     * perform an Envelope Cell Broadcast
     * @param Cell Broadcast page TLV, as String
     * @return APDUResponse Object
     *  Send the following string :
     *  "D2XX8202 8381" + Cell Broadcast page TLV
     */
    public APDUResponse envelopeCellBroadcast(String Page);

    /**
     * perform a predefined Envelope Mo Short Message Control
     * @return APDUResponse Object
     *  Send the following string :
     *  "D5218202 82818605 81332255 11860B91 
     *   33225511 33557799 11229307 00000000
     *   000000"
     */
    public APDUResponse envelopeMoShortMessageControl();
}
