//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_cprv;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Cprv extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_cprv";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
    
    public Test_Api_2_Ueh_Cprv() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        boolean result = false;
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
          
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                         "8008" + // TLV UICC Toolkit application specific parameters
                         "01" +   // V Priority Level
                         "00" +   // V Max. number of timers
                         "00" +   // V Maximum text length for a menu entry
                         "00" +   // V Maximum number of menu entries                              
                         "00" +   // V Install with Maximum number of channels 
                         "00" +   // LV Minimum Security Level field
                         "00" +   // LV TAR Value(s) 
                         "00" );  // V Maximum number of services
        
        test.reset();
        test.terminalProfileSession("1719");
        
        
        /**********************************************************************/
        /** Testcase 1 . Try to use the compareValue method with a null       */ 
        /** compareBuffer                                                     */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp("8B244008 81556677 887FF600 11291200" +
                           "00041302 7000000E 0D080000 00200101" +
                         "00000000 0100");
        
        /**********************************************************************/
        /** Testcase 2 . Try to use the compareValue method with              */ 
        /** compareOffset > compareBuffer.length                              */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp("8B244008 81556677 887FF600 11291200" +
                         "00041302 7000000E 0D080000 00200101" +
                         "00000000 0100");
        /**********************************************************************/
        /** Testcase 3 . Try to use the compareValue method with              */ 
        /** compareOffset < 0                                                 */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp("8B244008 81556677 887FF600 11291200" +
                         "00041302 7000000E 0D080000 00200101" +
                         "00000000 0100");
        
        /**********************************************************************/
        /** Testcase 4 . Try to use the compareValue method                   */ 
        /** compareLength > compareBuffer .length                             */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp("8B244008 81556677 887FF600 11291200" +
                         "00041302 7000000E 0D080000 00200101" +
                         "00000000 0100");
        
        /**********************************************************************/
        /** Testcase 5 . Try to use the compareValue method                   */ 
        /** compareLength + compareOffset > compareBuffer.length              */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp("8B244008 81556677 887FF600 11291200" +
                         "00041302 7000000E 0D080000 00200101" +
                         "00000000 0100");
        
        
        /**********************************************************************/
        /** Testcase 6 . Try to use the compareValue method with              */ 
        /** compareLength < 0                                                 */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp("8B244008 81556677 887FF600 11291200" +
                         "00041302 7000000E 0D080000 00200101" +
                         "00000000 0100");
        
        
        /**********************************************************************/
        /** Testcase 7 . Try to use the compareValue method with              */ 
        /**  valueOffset >= TLV Length                                        */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        
        
        /**********************************************************************/
        /** Testcase 8 . Try to use the compareValue method                   */ 
        /** valueOffset < 0                                                   */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                     "3344F58B 24400881 55667788 7FF60011" +
                     "29120000 04130270 00000E0D 08000000" +
                     "20010100 00000001 00");
        
        /**********************************************************************/
        /** Testcase 9 . Try to use the compareValue method                   */ 
        /** compareLength > TLV Length                                        */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        
        /**********************************************************************/
        /** Testcase 10 . Try to use the compareValue method                  */ 
        /** compareOffset + compareLength > TLV Length                        */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        
        /**********************************************************************/
        /** Testcase 11 . Try to use the compareValue method                  */ 
        /** compareBuffer   thrown ToolkitException.UNAVAILABLE_ELEMENT       */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        /**********************************************************************/
        /** Testcase 12 . Try to use the compareValue method with             */ 
        /** compareBuffer =81 11 22 33 44 F5                                  */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        
        /**********************************************************************/
        /** Testcase 13 . Try to use the compareValue method with             */ 
        /** compareBuffer =7F 11 22 33 44 F5                                  */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        
        /**********************************************************************/
        /** Testcase 14 . Try to use the compareValue method with             */ 
        /** compareBuffer =83 11 22 33 44 F5                                  */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        
        /**********************************************************************/
        /** Testcase 15 . Try to use the compareValue method with             */ 
        /** compareBuffer = 55 55 55 81 11 22 33 44 F5 55 55 55 55 55         */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        
        /**********************************************************************/
        /** Testcase 16 . Try to use the compareValue method with a           */ 
        /** compareBuffer = 55 55 55 81 10 22 33 44 F5 55 55 55 55 55         */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        
        /**********************************************************************/
        /** Testcase 17 . Try to use the compareValue method with a           */ 
        /** compareBuffer = 55 55 55 81 12 22 33 44 F5 55 55 55 55 55         */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        /**********************************************************************/
        /** Testcase 18 . Try to use the compareValue method with length =0   */ 
        /** compareBuffer                                                     */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu("80C20000 34D13282 02838106 06811122" +
                      "3344F58B 24400881 55667788 7FF60011" +
                      "29120000 04130270 00000E0D 08000000" +
                      "20010100 00000001 00");
        
        
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        result = response.checkData("10" + APPLET_AID_1 + 
                                    "12CCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                    "CCCCCC");
        
        test.reset();
        test.terminalProfileSession("1719");
                                         
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return result;
    }
}   
