//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gcid;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Gcid extends UiccTestModel {
    
    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_gcid";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ueh_Gcid() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        boolean result = false;
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                           "800A" + // TLV UICC Toolkit application specific parameters
                           "01" +   // V Priority Level
                           "00" +   // V Max. number of timers
                           "10" +   // V Maximum text length for a menu entry
                           "01" +   // V Maximum number of menu entries
                           "01" +   // V Id of menu entry 1
                           "01" +   // V Position of menu entry 1
                           "07" +   // V Install with Maximum number of channels 
                           "00" +   // LV Minimum Security Level field
                           "00" +   // LV TAR Value(s) 
                           "00" );  // V Maximum number of services
        
        test.reset();
        test.terminalProfileSession("1719");
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 34D13282 02838106 05801122" +
                        "33448B25 40088155 6677887F F6001129" +
                        "12000004 14027000 000F0D08 00000020" +
                        "01010000 00000100 01");
        //Fetch Open Channel proctive command
        test.fetch("1C");
        test.terminalResponse("81030140 01820282 81030100 38028100" +
                              "35040100 00003902 0080");
        test.fetch("1C");
        test.terminalResponse("81030140 01820282 81030100 38028200" +
                              "35040100 00003902 0080");
        test.fetch("1C");
        test.terminalResponse("81030140 01820282 81030100 38028300" +
                              "35040100 00003902 0080");
        test.fetch("1C");
        test.terminalResponse("81030140 01820282 81030100 38028400" +
                              "35040100 00003902 0080");
        test.fetch("1C");
        test.terminalResponse("81030140 01820282 81030100 38028500" +
                              "35040100 00003902 0080");
        test.fetch("1C");
        test.terminalResponse("81030140 01820282 81030100 38028600" +
                              "35040100 00003902 0080");
        test.fetch("1C");
        test.terminalResponse("81030140 01820282 81030100 38028700" +
                              "35040100 00003902 0080");
        
        /**********************************************************************/
        /** Testcase 1. Test with Successful Call                                */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeEventDownloadChannelStatus("38028100");
        
        
        
        /**********************************************************************/
        /** Testcase 2. Test with Two channel status elements                 */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeEventDownloadChannelStatus("38028400 38028500");
        
        
        /**********************************************************************/
        /** Testcase 3. Test with verify current TLV                            */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeEventDownloadChannelStatus("38020605");
        
        
        /**********************************************************************/
        /** Testcase 4. Test with Envelope Menu Selection without Channel     */
        /** Status                                                            */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeMenuSelection("100101","");
        
        
        
        /**********************************************************************/
        /** Testcase 5. Test with Successful Channel status value = 0x0600    */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeEventDownloadChannelStatus("38020600");
        
        
        
        /**********************************************************************/
        /** Testcase 6. Test with OUT_OF_TLV_BOUNDARIES Exception                */
        /**********************************************************************/      
        
        response = test.sendApdu("80C20000 08010682 02828138 00");
        
        
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        result = response.checkData("10" + APPLET_AID_1 + 
                                    "06CCCCCC CCCCCC");
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                           
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return result;
    }
}
    
      
