//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_glen;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Glen extends UiccTestModel {
    
    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_glen";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ueh_Glen() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        boolean result = false;
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        response = test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "00" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
        
        test.reset();
        test.terminalProfileSession("1719");
          
        /**********************************************************************/
        /** Testcase 1. test the getLength() method with a length = 0x31      */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 33D13182 0283818B 2B400881" +
                        "55667788 7FF60011 29120000 041A0270" +
                        "0000150D 08000000 20010100 00000001" +
                        "000A0B0C 0D0E0F10");
        
        /**********************************************************************/
        /** Testcase 2. test the getLength() method with a length = 0x7F      */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 81D17F82 0283818B 79400881" +
                        "55667788 7FF60011 29120000 04680270" +
                        "0000630D 08000000 20010100 00000001" +
                        "000A0B0C 0D0E0F10 12131415 16171819" +
                        "1A1B1C1D 1E1F2021 22232425 26272829" +
                        "2A2B2C2D 2E1F2021 22232425 26272829" +
                        "2A2B2C2D 2E1F2021 22232425 26272829" +
                        "2A2B2C2D 2E1F2021 22232425 26272829" +
                        "2A2B2C2D 2E1F");
        /**********************************************************************/
        /** Testcase 3.  test the getLength() method with a length = 81 80    */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 83D18180 82028381 8B7A4008" +
                        "81556677 887FF600 11291200 00046902" +
                        "70000064 0D080000 00200101 00000000" +
                        "01000A0B 0C0D0E0F 10121314 15161718" +
                        "191A1B1C 1D1E1F20 21222324 25262728" +
                        "292A2B2C 2D1E1F20 21222324 25262728" +
                        "292A2B2C 2D1E1F20 21222324 25262728" +
                        "292A2B2C 2D1E1F20 21222324 25262728" +
                        "292A2B2C 2D1E1F20");
        /**********************************************************************/
        /** Testcase 4.  test the getLength() method with a length = 81 FC    */
        /**********************************************************************/      
        //Trigger applet
        //envelopeSmsPp use send apdu command to see the rechearch tag 
        test.sendApdu(  "80C20000 FFD181FC 82028381 8B244008" +
                        "81556677 887FF600 11291200 00041302" +
                        "7000000E 0D080000 00200101 00000000" +
                        "01003381 CF0C0D0E 0F101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B 1C1D1E1F 20101213 14151617" +
                        "18191A1B");
            
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        result = response.checkData("10" + APPLET_AID_1 + 
                                    "04CCCCCC CC");
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                           
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return result;
    }
}   
