//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gtsz;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Gtsz extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_gtsz";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ueh_Gtsz() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        boolean result = false;
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "00" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
        
        test.reset();
        test.terminalProfileSession("1719");
          
        /**********************************************************************/
        /** Testcase 1 and 2. Test with unrecognized envelope of length 0x33  */ 
        /** (including tag and length)                                        */
        /**********************************************************************/      
        
        test.sendApdu(  "80C20000 3301318202 8381FF01 013328" +
                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                        "FFFFFFFF FFFFFFFF");
        
        //Fetch the Display Text
        test.fetch("14");
        
        //Terminal Response
        test.terminalResponse("81030121 00820282 81830100");
        
          
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        result = response.checkData("10" + APPLET_AID_1 + 
                                    "02CCCC");
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                           
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
      
        return result;
    }
}   
