//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_apt_efse;

import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;


public class Test_Ufw_Apt_Efse extends UiccTestModel {
    static final String CAP_FILE_PATH = "uicc/usim/test/usatframework/ufw_apt_efse";
    static final String CLASS_AID_1   = "A0000000 871005FF FFFFFF89 50010001";
    static final String APPLET_AID_1  = "A0000000 871005FF FFFFFF89 50010102";
    
    static final String SMS_F_SINGLE = "8B244008 81556677 887FF600 11291200 00041302" +
                                       "7000000E 0D080000 00500101 00000000 0100";
    
    static final String SMS_F_CONCAT1 = "8B574008 81556677 887FF600 11291200 00044607" +
                                        "0003A102 01700000 7C0D0800 00005001 01000000" +
                                        "00010011 11111111 11111111 11111111 11111111" +
                                        "11111111 11111111 11111111 11111111 11111111" +
                                        "11111111 11111111 11";
    
    static final String SMS_F_CONCAT2 = "8B574008 81556677 887FF600 11291200 00044605" +
                                        "0003A102 02222222 22222222 22222222 22222222" +
                                        "22222222 22222222 22222222 22222222 22222222" +
                                        "22222222 22222222 22222222 22222222 22222222" +
                                        "22222222 22222222 22";
    
    private USimAPITestCardService test;
    APDUResponse response;

    public Test_Ufw_Apt_Efse() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }

    public boolean run() {
        boolean result = false;

        // test script
        test.reset();
        test.terminalProfileSession("1719");

        // Install package
        test.loadPackage(CAP_FILE_PATH);

        // Install Applet1
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1,
            "8008" + // TLV UICC Toolkit application specific parameters
            "01" + // V Priority Level
            "00" + // V Max. number of timers
            "00" + // V Maximum text length for a menu entry
            "00" + // V Maximum number of menu entries                              
            "00" + // V Maximum number of channels 
            "00" + // LV Minimum Security Level field
            "00" + // LV TAR Value(s) 
            "00"); // V Maximum number of services

        test.reset();
        test.terminalProfileSession("1719");
        
        /**
         * Testcase 1
         */
        
        // Single SMS PP Formatted Data Download
        response = test.envelopeSmsPp(SMS_F_SINGLE);
        result = response.checkSw("9000");

        // Concatenated SMS PP Formatted Data Download
        response = test.envelopeSmsPp(SMS_F_CONCAT1);
        result = response.checkSw("9000");

        response = test.envelopeSmsPp(SMS_F_CONCAT2);
        result = response.checkSw("9000");


        /**
         * Testcase 2
         */
        
        // Single SMS PP Formatted Data Download
        response = test.envelopeSmsPp(SMS_F_SINGLE);
        result = response.checkSw("9000");

        // Concatenated SMS PP Formatted Data Download
        response = test.envelopeSmsPp(SMS_F_CONCAT1);
        result = response.checkSw("9000");

        response = test.envelopeSmsPp(SMS_F_CONCAT2);
        result = response.checkSw("9000");
        
        test.unrecognizedEnvelope();
        
        // Single SMS PP Formatted Data Download
        response = test.envelopeSmsPp(SMS_F_SINGLE);
        result = response.checkSw("9000");
        
        // Concatenated SMS PP Formatted Data Download
        response = test.envelopeSmsPp(SMS_F_CONCAT1);
        result = response.checkSw("9000");

        response = test.envelopeSmsPp(SMS_F_CONCAT2);
        result = response.checkSw("9000");
        
        
        
        /***********************************/
        /**         Check results          */
        /***********************************/
        // Select applet1
        response = test.selectApplication(APPLET_AID_1);
        result &= response.checkData("10" + APPLET_AID_1 + "06CCCCCC CCCCCC");

        test.reset();
        test.terminalProfileSession("1719");;

        // Delete Applet1 
        test.deleteApplet(APPLET_AID_1);

        // Delete Package
        test.deletePackage(CAP_FILE_PATH);

        return result;
    }
}
