//-----------------------------------------------------------------------------
//Test_ufw_fws_inda.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_fws_inda;
//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------

import org._3gpp.ct.wg6.usim.jcapi.userclass.USimAPITestCardService;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;

/**
 * Test Area : uicc.usim.test.ufwk.ufw_fws_inda
 *
 * @version 0.0.1 - 9 sept. 2005
 * @author 3GPP T3 SWG API
 */
public class Test_Ufw_Fws_Inda extends UiccTestModel {


    static final String             CAP_FILE_PATH   = "uicc/usim/test/usatframework/ufw_fws_inda";

    private final String            CLASS_AID_1     = "A0000000 871005FF FFFFFF89 50010001";
    private final String            APPLET_AID_1    = "A0000000 871005FF FFFFFF89 50010102";

    private final String            CLASS_AID_2     = "A0000000 871005FF FFFFFF89 50020001";
    private final String            APPLET_AID_2    = "A0000000 871005FF FFFFFF89 50020102";

    private final String            CLASS_AID_3     = "A0000000 871005FF FFFFFF89 50030001";
    private final String            APPLET_AID_3    = "A0000000 871005FF FFFFFF89 50030102";

    private final String            CLASS_AID_4     = "A0000000 871005FF FFFFFF89 50040001";
    private final String            APPLET_AID_4    = "A0000000 871005FF FFFFFF89 50040102";
    
    private final String            CLASS_AID_5     = "A0000000 871005FF FFFFFF89 50050001";
    private final String            APPLET_AID_5    = "A0000000 871005FF FFFFFF89 50050102";

    private final String            CLASS_AID_6     = "A0000000 871005FF FFFFFF89 50060001";
    private final String            APPLET_AID_6    = "A0000000 871005FF FFFFFF89 50060102";
    
    
    /** */
    private USimAPITestCardService test;
    /** contains the response of the processed apdu*/
    private APDUResponse response;

    private static String           ADF_1_AID           = "A0000000090005FFFFFFFF89E0000002";
    /** */
    public Test_Ufw_Fws_Inda() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    /**
     * @todo terminal profile
     */
    public boolean run() {
            
            boolean result = false;
         
            // Reset
            test.reset();
            test.terminalProfileSession("07010000 0102");
            // Install package
            test.loadPackage(CAP_FILE_PATH);
            // Install Applet1
            test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                                "8008" + // TLV UICC Toolkit application specific parameters
                                "01" +   // V Priority Level
                                "00" +   // V Max. number of timers
                                "00" +   // V Maximum text length for a menu entry
                                "00" +   // V Maximum number of menu entries                              
                                "00" +   // V Maximum number of channels 
                                "00" +   // LV Minimum Security Level field
                                "00" +   // LV TAR Value(s) 
                                "00" );  // V Maximum number of services
            
          
            //Send terminal profile
            test.reset();
            test.terminalProfileSession("07010000 0102");
            
            // Test Case 1 : Envelope(SMS_PP) single and formatted
            // 1.1 Single SMS Ciphered,CC,No PoR
            response = test.envelopeSmsPp("8B2E4008 81556677 887FF600 11291200"
                                        + "00041D02 70000018 150E0011 11500101"
                                        + "B39B117C 22690D7F 6FB40A53 134D547C");
            result = response.checkSw("9000");

            // 1.2 Concateneted SMS 2 segments, Ciphered,CC,No PoR
            response = test.envelopeSmsPp("8B819D40 08815566 77887FF6 00112912"
                                        + "0000048C 070003A9 02017000 00B0150E"
                                        + "00111150 0101535C 62A19053 6C9EBFB7"
                                        + "8453A928 720BACE7 52235486 82C60DE9"
                                        + "599C8D9C BE1DCC9F A4933327 194BCFA8"
                                        + "1D8160B8 D997F305 AC18B774 95C99479"
                                        + "C3A2208C A45E97C4 3043B894 D3EB5872"
                                        + "56BE2748 1A764B97 E36BBA87 CA8ED1F6"
                                        + "70A74D83 C897CBBB 1454BE7B 6BA61187"
                                        + "9567DD18 DACE656B 2AD3EC71 AADFB2F1");
            result &= response.checkSw("9000");
            
            response = test.envelopeSmsPp("8B454008 81556677 887FF600 11291200"
                                        + "00043405 0003A902 02BCD496 0FB70BBB"
                                        + "5D3D81CA BC0163DF B58F1CB7 87AC5265"
                                        + "7A309399 D1FAFBDB B08B8D7C F2E32F23"
                                        + "C4FC7BA2 D75485");
            result &= response.checkSw("9000");
            
            // Test Case 2 : Envelope(SMS_PP) single and formatted
            
            // Install Applet2
            test.installApplet(CAP_FILE_PATH, CLASS_AID_2, APPLET_AID_2, 
                                "8008" + // TLV UICC Toolkit application specific parameters
                                "01" +   // V Priority Level
                                "00" +   // V Max. number of timers
                                "00" +   // V Maximum text length for a menu entry
                                "00" +   // V Maximum number of menu entries                              
                                "00" +   // V Maximum number of channels 
                                "00" +   // LV Minimum Security Level field
                                "00" +   // LV TAR Value(s) 
                                "00" );  // V Maximum number of services

            // Reset
            test.reset();
            test.terminalProfileSession("07010000 0102");
            
            // 2.1 Single SMSPP is send to applet 1
            // Message is ciphered and authenticated using CC
            response = test.envelopeSmsPp("8B2E4008 81556677 887FF600 11291200"
                                        + "00041D02 70000018 150E0011 11500101"
                                        + "0C77BF44 F90EFFC1 3DB45DDA A7299F99");
            result &= response.checkSw("9000");
            
            // 2.2 Concateneted SMS 2 segments, Ciphered,CC,No PoR
            response = test.envelopeSmsPp("8B819D40 08815566 77887FF6 00112912"
                                        + "0000048C 070003A9 02017000 00B0150E"
                                        + "00111150 0101535C 62A19053 6C9EBFB7"
                                        + "8453A928 720BACE7 52235486 82C60DE9"
                                        + "599C8D9C BE1DCC9F A4933327 194BCFA8"
                                        + "1D8160B8 D997F305 AC18B774 95C99479"
                                        + "C3A2208C A45E97C4 3043B894 D3EB5872"
                                        + "56BE2748 1A764B97 E36BBA87 CA8ED1F6"
                                        + "70A74D83 C897CBBB 1454BE7B 6BA61187"
                                        + "9567DD18 DACE656B 2AD3EC71 AADFB2F1");
            result &= response.checkSw("9000");
            
            response = test.envelopeSmsPp("8B454008 81556677 887FF600 11291200"
                                        + "00043405 0003A902 02BCD496 0FB70BBB"
                                        + "5D3D81CA BC0163DF B58F1CB7 87AC5265"
                                        + "7A309399 D1FAFBDB B08B8D7C F2E32F23"
                                        + "C4FC7BA2 D75485");
            result &= response.checkSw("9000");
            
            // 2.3 Single SMSPP is sent to applet2 without any security
            response = test.envelopeSmsPp("8B254008 81556677 887FF600 11291200"
                                        + "00041402 7000000F 0D080010 10500201"
                                        + "00000000 010005");
            result &= response.checkSw("9000");

            // 2.4 Concateneted SMS 2 segments without security is send to applet2
            response = test.envelopeSmsPp("8B819D40 08815566 77887FF6 00112912"
                                        + "0000048C 070003A9 02017000 00A40D08"
                                        + "00101050 02010000 00000100 01020304"
                                        + "05060708 090A0B0C 0D0E0F10 11121314"
                                        + "15161718 191A1B1C 1D1E1F20 21222324"
                                        + "25262728 292A2B2C 2D2E2F30 31323334"
                                        + "35363738 393A3B3C 3D3E3F40 41424344"
                                        + "45464748 494A4B4C 4D4E4F50 51525354"
                                        + "55565758 595A5B5C 5D5E5F60 61626364"
                                        + "65666768 696A6B6C 6D6E6F70 71727374");
            result &= response.checkSw("9000");
            
            response = test.envelopeSmsPp("8B394008 81556677 887FF600 11291200"
                                        + "00042805 0003A902 02757677 78797A7B"
                                        + "7C7D7E7F 80818283 84858687 88898A8B"
                                        + "8C8D8E8F 90919293 9495FF");
            result &= response.checkSw("9000");

            // Test Case 3 : Envelope(SMS_PP) with wrong checksum
            
            // 3.1 Single SMSPP is sent to applet1 with a wrong checksum
            response = test.envelopeSmsPp("8B2D4008 81556677 887FF600 11291200"
                                        + "00041C02 70000017 150A0010 11500101"
                                        + "00000000 0100509E 92CE4042 0C8A05");
            result &= response.checkSw("9000");

            // 3.2 A concatenated SMSPP is send to applet 1 with wrong checksum
            response = test.envelopeSmsPp("8B819D40 08815566 77887FF6 00112912"
                                        + "0000048C 070003A9 02017000 00AC150A"
                                        + "00101150 01010000 00000100 22DC052A"
                                        + "7DD07248 01020304 05060708 090A0B0C"
                                        + "0D0E0F10 11121314 15161718 191A1B1C"
                                        + "1D1E1F20 21222324 25262728 292A2B2C"
                                        + "2D2E2F30 31323334 35363738 393A3B3C"
                                        + "3D3E3F40 41424344 45464748 494A4B4C"
                                        + "4D4E4F50 51525354 55565758 595A5B5C"
                                        + "5D5E5F60 61626364 65666768 696A6B6C");
            result &= response.checkSw("9000");

            response = test.envelopeSmsPp("8B414008 81556677 887FF600 11291200"
                                        + "00043005 0003A902 026D6E6F 70717273"
                                        + "74757677 78797A7B 7C7D7E7F 80818283"
                                        + "84858687 88898A8B 8C8D8E8F 90919293"
                                        + "949596");
            result &= response.checkSw("9000");

            // Test case 4 : Framework checks the CC and deciphers the data
            
            // Install applet 3
            test.installApplet(CAP_FILE_PATH, CLASS_AID_3, APPLET_AID_3, 
                               "8008" + // TLV UICC Toolkit application specific parameters
                               "01" +   // V Priority Level
                               "00" +   // V Max. number of timers
                               "00" +   // V Maximum text length for a menu entry
                               "00" +   // V Maximum number of menu entries                              
                               "00" +   // V Maximum number of channels 
                               "00" +   // LV Minimum Security Level field
                               "00" +   // LV TAR Value(s) 
                               "00" );  // V Maximum number of services

            // Reset
            test.reset();
            test.terminalProfileSession("07010000 0102");
            
            // Send an envelope SMSPP ciphered and authenticated to applet3
            response = test.envelopeSmsPp("8B2E4008 81556677 887FF600 11291200"
                                        + "00041D02 70000018 150E0011 11500301"
                                        + "65A55A74 13C21756 2E361633 A9148E36");
            result &= response.checkSw("9000");
            
            // Test case 5 : Triggering two different applet with different security on Envelope(SMS-CB) formatted

            // Install applet 4
            test.installApplet(CAP_FILE_PATH, CLASS_AID_4, APPLET_AID_4, 
                               "8008" + // TLV UICC Toolkit application specific parameters
                               "01" +   // V Priority Level
                               "00" +   // V Max. number of timers
                               "00" +   // V Maximum text length for a menu entry
                               "00" +   // V Maximum number of menu entries                              
                               "00" +   // V Maximum number of channels 
                               "00" +   // LV Minimum Security Level field
                               "00" +   // LV TAR Value(s) 
                               "00" );  // V Maximum number of services
            
            // Reset
            test.reset();
            test.terminalProfileSession("07010000 0102");
            
            // Send an authenticated and ciphered SMS-CB envelope to applet 3
            response = test.envelopeCellBroadcast("8C58A750 1093F611 00181506 00111150"
                                                + "0301EECE 5D431EF0 48F29979 ED042016"
                                                + "3B460000 00000000 00000000 00000000"
                                                + "00000000 00000000 00000000 00000000"
                                                + "00000000 00000000 00000000 00000000"
                                                + "00000000 00000000 0000");
            result &= response.checkSw("9000");
            
            // Send an SMS-CB envelope to applet4 without any security
            response = test.envelopeCellBroadcast("8C58A750 1093F611 000F0D00 00101050"
                                                + "04010000 00000100 03000000 00000000"
                                                + "00000000 00000000 00000000 00000000"
                                                + "00000000 00000000 00000000 00000000"
                                                + "00000000 00000000 00000000 00000000"
                                                + "00000000 00000000 0000");
            result &= response.checkSw("9000");
            
            // Test case 6 : Envelope(SMS-CB) formatted with wrong checksum
            
            // Send an SMS-CB formatted envelope to applet3 with a wrong checksum
            response = test.envelopeCellBroadcast("8C58A750 1093F611 00171502 00101150"
                                                + "03010000 00000100 6660AAE1 8A4F57D1"
                                                + "04000000 00000000 00000000 00000000"
                                                + "00000000 00000000 00000000 00000000"
                                                + "00000000 00000000 00000000 00000000"
                                                + "00000000 00000000 0000");
            result &= response.checkSw("9000");
            
            // Test case 7 : Framework checks the security and deciphered data 
            
            // Install applet 5
            test.installApplet(CAP_FILE_PATH, CLASS_AID_5, APPLET_AID_5, 
                               "8008" + // TLV UICC Toolkit application specific parameters
                               "01" +   // V Priority Level
                               "00" +   // V Max. number of timers
                               "00" +   // V Maximum text length for a menu entry
                               "00" +   // V Maximum number of menu entries                              
                               "00" +   // V Maximum number of channels 
                               "00" +   // LV Minimum Security Level field
                               "00" +   // LV TAR Value(s) 
                               "00" );  // V Maximum number of services

            // Reset
            test.reset();
            test.terminalProfileSession("07010000 0102");
            
            // 7.1 Send an authenticated and ciphered SMSPP update to Applet 5
            // Select EF_SMS under ADF
            test.selectApplication(ADF_1_AID);
            test.selectFile("6F3C"); 
            test.updateRecord("01","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 1D027000 0018150E 00111150"
                                      + "0501B4E2 5124EA32 491C94DA E0BE3D2D"
                                      + "EFCCFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
            result &= response.checkSw("9000");
            
            // 7.2 A concatenated SMS_PP update is send to applet 5
            test.updateRecord("00","02","03020101 40088155 6677887F F6001129"
                                      + "12000004 8C070003 A9020170 0000B015"
                                      + "0E001111 500501C9 E2336221 B902CA18"
                                      + "6930F579 6D1A328A 7AA3E4B9 B16E96DD"
                                      + "58F2F684 9C8380FD 405E9C5F C2F59C33"
                                      + "9429E820 1A565258 D4DC48C6 6C721842"
                                      + "8A82C83C 0CD6A22A ED0336BA 54303786"
                                      + "C3A59723 E09748FD 89A07B9E 0227714B"
                                      + "11F1E07F CD5CDDB7 2DDB1CEC 9AE67437"
                                      + "7AB00CD4 C6EF6370 6CCE9773 0E57C1F4"
                                      + "E2FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

            test.updateRecord("02","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 34050003 A90202E8 CB447BCF"
                                      + "1227BC4C BF6CA3C7 37CB48BF D5C201D7"
                                      + "EA2C9BAF 65241A58 A1232834 907078EA"
                                      + "D66A94B6 554F25AC 3AFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
            result &= response.checkSw("9000");
            
            // Test case 8 : Trigger two applets with different security
            
            // Install applet 6
            test.installApplet(CAP_FILE_PATH, CLASS_AID_6, APPLET_AID_6, 
                               "8008" + // TLV UICC Toolkit application specific parameters
                               "01" +   // V Priority Level
                               "00" +   // V Max. number of timers
                               "00" +   // V Maximum text length for a menu entry
                               "00" +   // V Maximum number of menu entries                              
                               "00" +   // V Maximum number of channels 
                               "00" +   // LV Minimum Security Level field
                               "00" +   // LV TAR Value(s) 
                               "00" );  // V Maximum number of services

            // Reset
            test.reset();
            test.terminalProfileSession("07010000 0102");
            
            // Select EF_SMS under ADF
            test.selectApplication(ADF_1_AID);
            test.selectFile("6F3C");
            
            // 8.1 A single SMSPP is send to applet 5 by update EF_SMS
            test.updateRecord("01","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 1D027000 0018150E 00111150"
                                      + "050178D2 06CE6095 2657B950 9A13C857"
                                      + "798CFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
            result &= response.checkSw("9000");
            
            // 8.2 A concatenated SMSPP is send to applet 5 by update EF_SMS
            test.updateRecord("01","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 8C070003 A9020170 0000B015"
                                      + "0E001111 500501C9 E2336221 B902CA18"
                                      + "6930F579 6D1A328A 7AA3E4B9 B16E96DD"
                                      + "58F2F684 9C8380FD 405E9C5F C2F59C33"
                                      + "9429E820 1A565258 D4DC48C6 6C721842"
                                      + "8A82C83C 0CD6A22A ED0336BA 54303786"
                                      + "C3A59723 E09748FD 89A07B9E 0227714B"
                                      + "11F1E07F CD5CDDB7 2DDB1CEC 9AE67437"
                                      + "7AB00CD4 C6EF6370 6CCE9773 0E57C1F4"
                                      + "E2FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

            test.updateRecord("02","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 34050003 A90202E8 CB447BCF"
                                      + "1227BC4C BF6CA3C7 37CB48BF D5C201D7"
                                      + "EA2C9BAF 65241A58 A1232834 907078EA"
                                      + "D66A94B6 554F25AC 3AFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
            result &= response.checkSw("9000");

            // 8.3 A single SMSPP update is send to applet 6
            test.updateRecord("01","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 14027000 000F0D08 00101050"
                                      + "06010000 00000100 05FFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
            result &= response.checkSw("9000");

            // 8.4 A concateneted SMSPP update is send to applet 6
            test.updateRecord("01","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 8C070003 A9020170 0000A40D"
                                      + "08001010 50060100 00000001 00010203"
                                      + "04050607 08090A0B 0C0D0E0F 10111213"
                                      + "14151617 18191A1B 1C1D1E1F 20212223"
                                      + "24252627 28292A2B 2C2D2E2F 30313233"
                                      + "34353637 38393A3B 3C3D3E3F 40414243"
                                      + "44454647 48494A4B 4C4D4E4F 50515253"
                                      + "54555657 58595A5B 5C5D5E5F 60616263"
                                      + "64656667 68696A6B 6C6D6E6F 70717273"
                                      + "74FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

            test.updateRecord("02","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 28050003 A9020275 76777879"
                                      + "7A7B7C7D 7E7F8081 82838485 86878889"
                                      + "8A8B8C8D 8E8F9091 92939495 96FFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
            result &= response.checkSw("9000");

            // Test case 9 : SMSPP update with wrong checksum
            
            // 9.1 A single SMSPP update is send to applet 5 with a wrong checksum
            test.updateRecord("01","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 1C027000 0017150A 00101150"
                                      + "05010000 00000100 1122C83C AF4D4DD7"
                                      + "07FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
            result &= response.checkSw("9000");

            // 9.2 A concateneted SMSPP update is send to applet 5 with a wrong checksum
            test.updateRecord("01","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 8C070003 A9020170 0000AC15"
                                      + "0A001011 50050100 00000001 0077497E"
                                      + "59496B10 40010203 04050607 08090A0B"
                                      + "0C0D0E0F 10111213 14151617 18191A1B"
                                      + "1C1D1E1F 20212223 24252627 28292A2B"
                                      + "2C2D2E2F 30313233 34353637 38393A3B"
                                      + "3C3D3E3F 40414243 44454647 48494A4B"
                                      + "4C4D4E4F 50515253 54555657 58595A5B"
                                      + "5C5D5E5F 60616263 64656667 68696A6B"
                                      + "6CFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

            test.updateRecord("02","04","03020101 40088155 6677887F F6001129"
                                      + "12000004 30050003 A902026D 6E6F7071"
                                      + "72737475 76777879 7A7B7C7D 7E7F8081"
                                      + "82838485 86878889 8A8B8C8D 8E8F9091"
                                      + "92939495 96FFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"
                                      + "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
            result &= response.checkSw("9000");

             //get test result
            response = test.selectApplication(APPLET_AID_1);
            result &= response.checkData("10"+APPLET_AID_1+ 
                                         "04CCCCCC CC");
            
            response = test.selectApplication(APPLET_AID_2);
            result &= response.checkData("10"+APPLET_AID_2+ 
                                         "02CCCC");
            
            response = test.selectApplication(APPLET_AID_3);
            result &= response.checkData("10"+APPLET_AID_3+ 
                                         "02CCCC");
            
            response = test.selectApplication(APPLET_AID_4);
            result &= response.checkData("10"+APPLET_AID_4+ 
                                         "01CC");

            response = test.selectApplication(APPLET_AID_5);
            result &= response.checkData("10"+APPLET_AID_5+ 
                                         "04CCCCCC CC");

            response = test.selectApplication(APPLET_AID_6);
            result &= response.checkData("10"+APPLET_AID_6+ 
                                         "02CCCC");

            // delete applet and package
            test.reset();
            test.terminalProfileSession("0701");
            
            test.deleteApplet(APPLET_AID_6);
            test.deleteApplet(APPLET_AID_5);
            test.deleteApplet(APPLET_AID_4);
            test.deleteApplet(APPLET_AID_3);
            test.deleteApplet(APPLET_AID_2);
            test.deleteApplet(APPLET_AID_1);
            test.deletePackage(CAP_FILE_PATH);

            return result;
    }
}
