//-----------------------------------------------------------------------------
// Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_hin_uehd;

//-----------------------------------------------------------------------------
// Imports
//-----------------------------------------------------------------------------


import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userinterface.*;


public class Test_Ufw_Hin_Uehd extends UiccTestModel
{

    /** path to the cap file of test applet */
    static final String            CAP_FILE_PATH = "uicc/usim/test/usatframework/ufw_hin_uehd";

    /** class AID of test applet */
    static final String            CLASS_AID_1   = "A0000000 871005FF FFFFFF89 50010001";

    /** instance AID of test applet */
    static final String            APPLET_AID_1  = "A0000000 871005FF FFFFFF89 50010101";

    private USimAPITestCardService test          = null;

    APDUResponse                   response      = null;

   private final String ADF_AID_1 = "A0000000090005FFFFFFFF89E0000002";

    public Test_Ufw_Hin_Uehd() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }

    public boolean run()
    {
        boolean result = false;

        // test script
        test.reset();
        test.terminalProfileSession("981301");

        // Install Applet1
        test.loadPackage(CAP_FILE_PATH);
        // Install Applet1
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1,
                            "8008" + // TLV UICC Toolkit application specific parameters
                            "01" +   // V Priority Level
                            "00" +   // V Max. number of timers
                            "20" +   // V Maximum text length for a menu entry
                            "00" +   // V Maximum number of menu entries
                            "00" +   // V Maximum number of channels
                            "00" +   // LV Minimum Security Level field
                            "00" +   // LV TAR Value(s)
                            "00" );  // V Maximum number of services


        //###############################################################################

        test.reset();
        response = test.terminalProfileSession("981301");

        //------------------------------------------------------------------------------
        //TC1 - check integrity with EVENT_FORMATTED_SMS_PP_ENV
        //------------------------------------------------------------------------------
        response =test.envelopeSmsPp( "06060000 00000000 0B31400B D0214365"+
                                      "8709F17F F6FFFFFF FFFFFFFF 1E027000"+
                                      "00190D00 00000050 01010000 00000000"+
                                      "A1B2C3D3 E4F5AABB CCDDEE");

        response = test.envelopeCallControlByNAA();
        response = test.fetch("13");
        result   = response.checkData("D0118103 01218082 0281028D 0604A1B2 C3D4E5");

        response = test.terminalResponse("810301 21808202 82810301 00");
        //------------------------------------------------------------------------------
        //TC2 - check integrity with FORMATTED_SMS_PP_UPD
        //------------------------------------------------------------------------------
        //response = test.selectApplication(ADF_AID_1); //select ADF1
        response = test.selectFile("3F00"); //select DFtelecom
        response = test.selectFile("7F10"); //select DFtelecom
        response = test.selectFile("6F3C"); //select EFsms
        response = test.updateRecord(  "01", "04",
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 3D027000 00380D08 00000050" +
                            "01010000 00000100 11223344 55667788" +
                            "99101112 13141516 1718191A 1B1C1D1E" +
                            "1F202422 23242526 2728292A 2B2C2D2E" +
                            "2F30FFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        response = test.envelopeCallControlByNAA();
        response = test.fetch("13");
        result   &= response.checkData("D0118103 01218082 0281028D 0604A1B2 C3D4E5");
        response = test.terminalResponse("810301 21808202 82810301 00");
        //------------------------------------------------------------------------------
        //TC3 - check integrity with UNFORMATTED_SMS_PP
        //------------------------------------------------------------------------------
        //5- unformatted SMS PP
        response = test.envelopeSmsPp( "06058011 2233448B 12000881"+
                                       "55667788 7FF60011 29120000"+
                                       "040101");
        response = test.envelopeCallControlByNAA();
        response = test.fetch("13");
        result   &= response.checkData("D0118103 01218082 0281028D 0604A1B2 C3D4E5");
        response = test.terminalResponse("810301 21808202 82810301 00");
        //------------------------------------------------------------------------------
        //TC4 - check integrity with UNFORMATTED_SMS_PP_UPD
        //------------------------------------------------------------------------------
        //response = test.selectApplication(ADF_AID_1); //select ADF1
        response = test.selectFile("3F00"); //select MF
        response = test.selectFile("7F10"); //select DFtelecom
        response = test.selectFile("6F3C"); //select EFsms
        response = test.updateRecord(  "01", "04",
                           " 03058011 22334400 0281557F F6001129 "+
                           " 12000004 3D010203 04050607 08090A0B "+
                           " 0C0D0E0F 10111213 14151617 18191A1B "+
                           " 1C1D1E1F 20212223 24252627 28292A2B "+
                           " 2C2D2E2F 30313233 34353637 38393A3B "+
                           " 3C3DFFFF FFFFFFFF FFFFFFFF FFFFFFFF "+
                           " FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF "+
                           " FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"+
                           " FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF "+
                           " FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF "+
                           " FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        response = test.envelopeCallControlByNAA();
        response = test.fetch("13");
        result   &= response.checkData("D0118103 01218082 0281028D 0604A1B2 C3D4E5");
        response = test.terminalResponse("810301 21808202 82810301 00");
        //------------------------------------------------------------------------------
        //TC5 - check integrity with UNFORMATTED_SMS_CB
        //------------------------------------------------------------------------------
        response = test.envelopeCellBroadcast("8C58A751 10A0F611 00300D00 00000050"
                + "01010000 00000000 01020304 05060708"
                + "090A0B0C 0D0E0F10 11121314 15161718"
                + "191A1B1C 1D1E1F20 21222324 25262728"
                + "292A2B2C 2D2E2F30 31323334 35363738"
                + "393A3B3C 3D3E3F40 4142");
        response = test.envelopeCallControlByNAA();
        response = test.fetch("13");
        result   &= response.checkData("D0118103 01218082 0281028D 0604A1B2 C3D4E5");
        response = test.terminalResponse("810301 21808202 82810301 00");
        //------------------------------------------------------------------------------
        //TC6 - check integrity with MO_SHORT_MESSAGE_CONTROL_BY_NAA
        //------------------------------------------------------------------------------
        response = test.envelopeMoShortMessageControl();
        response = test.envelopeCallControlByNAA();
        response = test.fetch("13");
        result   &= response.checkData("D0118103 01218082 0281028D 0604A1B2 C3D4E5");
        response = test.terminalResponse("810301 21808202 82810301 00");
        //------------------------------------------------------------------------------
        //TC7 - check integrity with FORMATTED_SMS_CB
        //------------------------------------------------------------------------------
        response = test.envelopeCellBroadcast("8C58A750 1093F611 00300D00 00000050"
                                            + "01010000 00000000 01020304 05060708"
                                            + "090A0B0C 0D0E0F10 11121314 15161718"
                                            + "191A1B1C 1D1E1F20 21222324 25262728"
                                            + "292A2B2C 2D2E2F30 31323334 35363738"
                                            + "393A3B3C 3D3E3F40 4142");
        response = test.envelopeCallControlByNAA();
        response = test.fetch("13");
        result   &= response.checkData("D0118103 01218082 0281028D 0604A1B2 C3D4E5");
        response = test.terminalResponse("810301 21808202 82810301 00");
        //------------------------------------------------------------------------------
        //TC 8,9,10 - check tlv list conversion with FORMATTED_SMS_PP_UPD
        //------------------------------------------------------------------------------
        //response = test.selectApplication(ADF_AID_1); //select ADF1
        response = test.selectFile("3F00"); //select DFtelecom
        response = test.selectFile("7F10"); //select DFtelecom
        response = test.selectFile("6F3C"); //select EFsms
        response = test.updateRecord(  "01", "04",
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 3D027000 00380D08 00000050" +
                            "01010000 00000100 11223344 55667788" +
                            "99101112 13141516 1718191A 1B1C1D1E" +
                            "1F202422 23242526 2728292A 2B2C2D2E" +
                            "2F30FFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");


        //------------------------------------------------------------------------------
        //TC 11,12,13 - check tlv list conversion  with UNFORMATTED_SMS_PP_UPD
      //------------------------------------------------------------------------------
        //response = test.selectApplication(ADF_AID_1); //select ADF1
        response = test.selectFile("3F00"); //select MF
        response = test.selectFile("7F10"); //select DFtelecom
        response = test.selectFile("6F3C"); //select EFsms
        response = test.updateRecord(  "01", "04",
                           " 03058011 22334400 0281557F F6001129 "+
                           " 12000004 3D010203 04050607 08090A0B "+
                           " 0C0D0E0F 10111213 14151617 18191A1B "+
                           " 1C1D1E1F 20212223 24252627 28292A2B "+
                           " 2C2D2E2F 30313233 34353637 38393A3B "+
                           " 3C3DFFFF FFFFFFFF FFFFFFFF FFFFFFFF "+
                           " FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF "+
                           " FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"+
                           " FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF "+
                           " FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF "+
                           " FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");

        //###############################################################################
        // Select test applet
        response = test.selectApplication(APPLET_AID_1);
        result &= response.checkData("10" + APPLET_AID_1 +
                                     "0DCCCCCC CCCCCCCC CCCCCCCC CCCC");

        test.reset();
        test.terminalProfileSession("981301");

        //###############################################################################
        // delete ppplet and package
        test.deleteApplet(APPLET_AID_1);
        test.deletePackage(CAP_FILE_PATH);

        return result;
    }//end method run()



}//end class