//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//----------------------------------------------------------------------------- 
package uicc.usim.test.usatframework.ufw_mha_erhd;
//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.test.util.* ;


public class Ufw_Mha_Erhd_1 extends TestToolkitApplet {
  
    /** result of specific testcase */
    boolean           bRes        = false;
    /** number of testcase */
    byte            testCaseNb      = (byte) 0x00;
    
    byte triggerNb=(byte)0x01;
    private byte[] sendData= {(byte)0x11, (byte)0x11, (byte)0x11, (byte)0x11, (byte)0x11, 
                              (byte)0x11, (byte)0x11, (byte)0x11, (byte)0x11, (byte)0x11};        
    private byte[] TEXT = {(byte)'T',(byte)'E',(byte)'X',(byte)'T',(byte)' ',(byte)'1'};
    private final short     eventList[] = { 
                      EVENT_FORMATTED_SMS_PP_ENV,
                      EVENT_UNFORMATTED_SMS_PP_ENV,
                      EVENT_FORMATTED_SMS_CB,
                      EVENT_UNFORMATTED_SMS_CB,
                      EVENT_FORMATTED_SMS_PP_UPD,
                      EVENT_UNFORMATTED_SMS_PP_UPD,
                      EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM}; 

    /**
     */
    private Ufw_Mha_Erhd_1 () {
    } 
  

    public static void install(byte[] bArray, short bOffset, byte bLength) {
 
         
        // Create a new applet instance.
        Ufw_Mha_Erhd_1 thisApplet = new Ufw_Mha_Erhd_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
              
        //- Applet registration     
        thisApplet.obReg.setEventList(thisApplet.eventList,(short)0,(short)(thisApplet.eventList.length));
    }
  
    public void processToolkit(short event) throws ToolkitException {
              
        bRes=false;

        switch(event) {
        //------------------------------------------------------------------Test case 1 to 4---------------------------------------------------------
        // For these events the EnvelopeResponseHandler is not available        
        case EVENT_FORMATTED_SMS_PP_UPD:
        case EVENT_UNFORMATTED_SMS_PP_UPD:        
        case EVENT_FORMATTED_SMS_CB:
        case EVENT_UNFORMATTED_SMS_CB:            
            testCaseNb++;          
            //EnvelopeResponseHandler is not available
            getEnvelopeResponseHandlerNotAvailableException(testCaseNb);                                
            break;                       
                
        default:
        //-------------------------------------------------------------------Test cases 5 to 7---------------------------------------------------------
        // These tests cases are only for EVENT_FORMATTED_SMS_PP_ENV, EVENT_UNFORMATTED_SMS_PP_ENV and
        // EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
        // The value of testCaseNb must be 5
        //-----------------------------------------------------------------------------------------------------------------------------------------------
            bRes=true;
            switch(testCaseNb) {


            // Test cases 5,6,7 
            // In the first trigger the application builds the response and calls the 
            // post() method in the case of EVENT_FORMATTED_SMS_PP_ENV and EVENT_UNFORMATTED_SMS_PP_ENV
            // and posAsBERTLV() method in case of EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
            // All methods of EnvelopeResponseHandler are called and the EnvelopeResponse handler is not
            // available
            case (byte)4:
            case (byte)5:
            case (byte)6:
                if(triggerNb==(byte)0x01) {

                    try {
                        triggerNb=(byte)0x02;
                        EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandlerSystem.getTheHandler();
                        envRespHdlr.appendArray(sendData,(short)0x00,(short)sendData.length);                        
                        if(event==EVENT_FORMATTED_SMS_PP_ENV || event==EVENT_UNFORMATTED_SMS_PP_ENV) {
                            envRespHdlr.post(true);
                        } else {
                            envRespHdlr.postAsBERTLV(true,(byte)0x44);
                        }                        
                        
                        bRes=testAllMethodsOfEnvRespHandler(envRespHdlr);
                    }
                    catch(Exception e) {
                          bRes=false;
                    }
                // In the second trigger the applet builds a Display Text command 
                // All methods of EnvelopeResponseHandler are called and the EnvelopeResponse handler is not
                // available                        
                } else {                          
                    if(bRes) {
                        triggerNb=(byte)0x01;
                        try {                                   	
                            ProactiveHandler prHdlr=ProactiveHandlerSystem.getTheHandler();
                            EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandlerSystem.getTheHandler();
                            prHdlr.initDisplayText((byte)0x80,(byte)0x04,TEXT,(short)0,(short)TEXT.length);
                            prHdlr.send();
                            bRes=testAllMethodsOfEnvRespHandler(envRespHdlr);
                        }
                        catch(Exception e) {
                            bRes=false;
                        }
                    }       
                    testCaseNb++;             
                    reportTestOutcome(testCaseNb,bRes);                    
                }
                break;
            // Test case 8  multi-triggering  EVENT_UNFORMATTED_SMS_PP_ENV
            case (byte)7:
                try {                            	
                    EnvelopeResponseHandler envRespHdlr =EnvelopeResponseHandlerSystem.getTheHandler();
                }
                catch(Exception e) {
                    bRes=false;
                }          
                testCaseNb++;      
                reportTestOutcome(testCaseNb,bRes);                
                break;

            }                
                
                
                
                
                        
      }
    }
    

    /**
     * Methods try to get a instance of the EnvelopeResponseHandler class. If this
     * fails and a ToolkitException.HANDLER_NOT_AVAILABLE is thrown, the test
     * case will be reported as successful. Otherwise as failure.
     * 
     * @param testCaseNb Number of the current test case
     */
    private void getEnvelopeResponseHandlerNotAvailableException(byte testCaseNb) {
      bRes=false;
      try {
        //get the Envelope Response Handler
        EnvelopeResponseHandler enResHdr = EnvelopeResponseHandlerSystem.getTheHandler();
      }
      catch (ToolkitException e) {
        if (e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE) {
          bRes=true;
        }
      }
      catch(Exception exp) {
        bRes=false;
      }
      this.reportTestOutcome(testCaseNb,bRes);
    }
   
    //---------------------------------------------------------------------------------------
    // This method call all methods of EnvelopeResponseHandler including the inherited methods
    //---------------------------------------------------------------------------------------
    boolean testAllMethodsOfEnvRespHandler(EnvelopeResponseHandler envRespHdlr) {
        
        bRes=true;
        byte testSubCaseNb= (byte)0x01;

        while((bRes) && (testSubCaseNb<0x1B)) {

            try {
                switch(testSubCaseNb) {
                    case (byte)0x01:
                        EnvelopeResponseHandler envRespHdlrF = EnvelopeResponseHandlerSystem.getTheHandler();
                        bRes=false;
                        break;
                    case (byte)0x02:
                        envRespHdlr.post(true);
                        bRes=false;
                        break;
                    case (byte)0x03:
                        envRespHdlr.postAsBERTLV(true,(byte)0x33);
                        bRes=false;
                        break;
                    case (byte)0x04:
                        envRespHdlr.appendArray(sendData,(short)0x00,(short)sendData.length);
                        bRes=false;
                        break;
                    case (byte)0x05:
                        envRespHdlr.appendTLV((byte)0x66,(byte)0x77);
                        bRes=false;
                        break;
                    case (byte)0x06:
                        envRespHdlr.appendTLV((byte)0x66,sendData,(short)0x00,(short)sendData.length);
                        bRes=false;
                        break;
                    case (byte)0x07:
                        envRespHdlr.appendTLV((byte)0x66,(byte)0x77,(byte)0x22);
                        bRes=false;
                        break;
                    case (byte)0x08:
                        envRespHdlr.appendTLV((byte)0x66,(byte)0x77,sendData,(short)0x00,(short)sendData.length);
                        bRes=false;
                        break;                        
                    case (byte)0x09:
                        envRespHdlr.appendTLV((byte)0x66,sendData,(short)0x00,(short)sendData.length,sendData,(short)0x00,(short)sendData.length);
                        bRes=false;
                        break;
                    case (byte)0x0A:
                        envRespHdlr.appendTLV((byte)0x66,(byte)0x77,(short)0x88);
                        bRes=false;
                        break;
                    case (byte)0x0B:
                        envRespHdlr.appendTLV((byte)0x66,(short)0x77);
                        bRes=false;
                        break;
                    case (byte)0x0C:
                        envRespHdlr.appendTLV((byte)0x66,(short)0x77,(short)0x88);
                        bRes=false;
                        break;      
                    case (byte)0x0D:
                        envRespHdlr.clear();
                        bRes=false;
                        break;
                    case (byte)0x0E:
                        envRespHdlr.compareValue((short)0x01,sendData,(short)0x00,(short)sendData.length);
                        bRes=false;
                        break;
                    case (byte)0x0F:
                        envRespHdlr.copy(sendData,(short)0x00,(short)0x01);
                        bRes=false;
                        break;
                    case (byte)0x10:
                        envRespHdlr.copyValue((short)0x00,sendData,(short)0x00,(short)0x01);
                        bRes=false;
                        break;
                    case (byte)0x11:
                        envRespHdlr.findAndCompareValue((byte)0x44,sendData,(short)0x00);
                        bRes=false;
                        break;
                    case (byte)0x12:
                        envRespHdlr.findAndCompareValue((byte)0x44,(byte)0x01,(short)0x00,sendData,(short)0x00,(short)0x01);
                        bRes=false;
                        break;
                    case (byte)0x13:
                        envRespHdlr.findAndCopyValue((byte)0x44,sendData,(short)0x00);
                        bRes=false;
                        break;
                    case (byte)0x14:
                        envRespHdlr.findAndCopyValue((byte)0x44,(byte)0x01,(short)0x00,sendData,(short)0x00,(short)0x01);
                        bRes=false;
                        break;
                    case (byte)0x15:
                        envRespHdlr.findTLV((byte)0x44,(byte)0x01);
                        bRes=false;
                        break;
                    case (byte)0x16:
                        envRespHdlr.getCapacity();
                        bRes=false;  
                        break;                      
                    case (byte)0x17:
                        envRespHdlr.getLength();
                        bRes=false;
                        break;
                    case (byte)0x18:
                        envRespHdlr.getValueByte((short)0x00);
                        bRes=false;
                        break;
                    case (byte)0x19:
                        envRespHdlr.getValueLength();
                        bRes=false;
                        break;
                    case (byte)0x1A:
                        envRespHdlr.getValueShort((short)0x00);
                        bRes=false;
                        break;                                                
                }
            }
            catch(ToolkitException e) {
                if(e.getReason()!=ToolkitException.HANDLER_NOT_AVAILABLE) {
                    bRes=false;
                }
            }
            catch(Exception e) {
                bRes=false;
            }
            testSubCaseNb++;
        }
        return (bRes);
    }    
}